# PHP_API_VERSION
%global apiver  20170718
# ZEND_MODULE_API_NO
%global zendver 20170718
# PDO_DRIVER_API
%global pdover  20170320

%define php_mver 7.2
%define compat_build 1
%{!?compat_build:%define compatv %{nil}}
%{?compat_build:%define compatv 72}

%define phplib %{_libdir}/php%{compatv}
%define extdir %{phplib}/extensions
%define peardir %{_datadir}/php/pear
%define phpvar  /var/lib/php%{compatv}

%define _unpackaged_files_terminate_build 0

# don't build debug package
#define debug_package %{nil}
# don't binary strip
#define __spec_install_post %{nil}

%define build_fpm 1

%{!?_with_no_goto:%define _vm_goto 1}
%{?_with_no_goto:%define _vm_goto 0}

Summary: The PHP %{php_mver} HTML-embedded scripting language
Summary(ko): PHP %{php_mver} 엔진
Name: php%{compatv}
Version: %{php_mver}.14
Release: 1%{?dist}
Epoch: 2
Group: Development/Languages
License: PHP
Source0: http://www.php.net/distributions/php-%{version}.tar.bz2
Source2: info.php
Source3: macros.php
Source4: php-dependency.txt

Source100: pecl-extension.tar.bz2
Source101: httpd.conf
Source102: annyung_func_alias_table.php

# patch start
# oops patch to 1 - 99
Patch1: php-ini.patch
Patch2: php-version.patch
Patch3: php-libtool2.patch
Patch4: php-5.4.16-fpm-logpath.patch

# don' use %10, %11
# build env patch
Patch12: php-libgd-freetype.patch
Patch13: php-dba.patch
Patch15: php-phpize64.patch
Patch16: php-includedir.patch
Patch17: php-tmpdir.patch

# new functions
Patch30: php-gd-charspace.patch
Patch32: php-annyung-alias.patch
Patch33: php-annyung-zend-listed-table.patch
# Patch 34 and Patch 35 are dependent on patch 33
Patch34: php-annyung-include-file-check.patch
# Patch 35 is dependent on Patch 34
Patch35: php-annyung-image-attack.patch
# block '\0' to path after 5.3.4RC1. still need?
# don' use
Patch36: php-annyung-urldecode-hex-null.patch
Patch37: php-annyung-realpath-cache-force.patch

# patch for rhel5
Patch100: php-4.3.1-odbc.patch
Patch101: php-fc-dlopen.patch
Patch103: php-5.3.18-gnusrc.patch
Patch104: php-5.3.18-systzdata-v7.patch
Patch105: php-5.3.18-embed.patch

# patch third party extension
# don' use
#Patch201: php-sqlite-php54.patch
#Patch202: php-sqlite-config.patch

# private patch
# http://wiki.ohgaki.net/index.php?PHP%2Fpatch
Patch3000: php-allow_url_fopen-INI_ALL.patch

# offcial patch
Patch5001: php-7.2.15-official-b77391.patch
Patch5002: php-7.2.15-official-b75684.patch
Patch5003: php-7.2.15-official-b77273.patch
Patch5004: php-7.2.15-official-b77395.patch
Patch5005: php-7.2.15-official-b77339.patch
Patch5006: php-7.2.15-official-b77272.patch
Patch5007: php-7.2.15-official-b73281.patch
Patch5008: php-7.2.15-official-b77439.patch
Patch5009: php-7.2.15-official-b76839.patch

Patch9000: php-5.3.1-unofficial-bug-51056-fread.patch
Patch10000: php-annyung-php72-compat.patch

# security
#Patch6000: php-5.5.10-CVE-2013-7345.patch


# patch end
BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
Requires: webserver, php%{compatv}-common, libicu, bzip2-libs
Requires: openssl, zlib, libxml2
BuildRequires: readline-devel, ncurses-devel, zlib-devel, file >= 4, re2c
BuildRequires: libpng-devel, libjpeg-devel, db4-devel, gdbm-devel
#BuildRequires: openssl-devel, zlib-devel, libxml2-devel, mysql-devel
BuildRequires: openssl-devel, zlib-devel, libxml2-devel bison
BuildRequires: curl-devel, freetds-devel, freetype-devel
BuildRequires: libmcrypt-devel, mhash-devel, libicu-devel
BuildRequires: libevent-devel >= 1.4, net-snmp-devel sqlite-devel
#BuildRequires: httpd-devel, openldap-devel bzip2-devel MTA
BuildRequires: openldap-devel bzip2-devel MTA
BuildRequires: imap-devel gmp-devel unixODBC-devel
Provides: php%{compatv}api
Obsoletes: php%{compatv}-intl php%{compatv}-pdo php%{compatv}-xmlrpc php%{compatv}-mbstring

# SEE-ASLO
# recode conflict building with imap
# oci8 conflict building with ldap

%description
PHP %{php_mver} is an HTML-embedded scripting language.  PHP attempts to make it
easy for developers to write dynamically generated web pages.  PHP
also offers built-in database integration for several commercial
and non-commercial database management systems, so writing a
database-enabled web page with PHP is fairly simple.  The most
common use of PHP coding is probably as a replacement for CGI
scripts.

Building option:
	--with no_goto : if don't add vm kind option with goto..

%package cli
Group: Development/Languages
Summary: php %{php_mver} command line interface
Summary(ko): php %{php_mver} cli 인터페이스
Requires: php%{compatv}-common, readline, ncurses, zlib, openssl, libicu
Provides: php%{compatv}api
Obsoletes: php%{compatv}-intl php%{compatv}-pdo php%{compatv}-xmlrpc php%{compatv}-mbstring

%description cli
php %{php_mver} binary file to use in shell

%package fpm
Group: Development/Languages
Summary: php %{php_mver} fpm engine
Requires: php%{compatv}-fpm-conf, zlib, openssl, libicu, ncurses, libicu
Provides: php%{compatv}api
Obsoletes: php%{compatv}-intl php%{compatv}-pdo php%{compatv}-xmlrpc php%{compatv}-mbstring

%description fpm
php %{php_mver} fastcgi(fpm) server api

%package devel
Group: Development/Libraries
Summary: php %{php_mver} development file for making extensions
Summary: php %{php_mver} 확장 개발을 위한 파일들

%description devel
php %{php_mver} build file for making extensions

%package extension
Group: Development/Languages
Summary: php %{php_mver} shared extension
Requires: php%{compatv}api
Requires: libjpeg, file, curl, openldap, gmp, sqlite
#Requires: sqlite, mysql-shared, freetype, freetds, libpng, libmcrypt, mhash
Requires: freetype, libpng, libmcrypt, mhash
Requires: libicu, libevent >= 1.4, net-snmp-libs
# block centos' php
Obsoletes: php%{compatv}-bcmath php%{compatv}-calendar php%{compatv}-curl
Obsoletes: php%{compatv}-exit php%{compatv}-fileinfo php%{compatv}-ftp php%{compatv}-gd
Obsoletes: php%{compatv}-gettext php%{compatv}-json php%{compatv}-ldap php%{compatv}-mcrypt
Obsoletes: php%{compatv}-mysql php%{compatv}-mysqli php%{compatv}-opcache php%{compatv}-pdo-mysql
Obsoletes: php%{compatv}-pdo-sqlite php%{compatv}-snmp php%{compatv}-soap php%{compatv}-sqlite3
Obsoletes: php%{compatv}-xmlreader php%{compatv}-xmlwriter php%{compatv}-zip

# compatible php base package
Provides: php%{compatv}-bcmath php%{compatv}-calendar php%{compatv}-curl php%{compatv}-exit
Provides: php%{compatv}-fileinfo php%{compatv}-ftp php%{compatv}-gd php%{compatv}-gettext
Provides: php%{compatv}-json php%{compatv}-ldap php%{compatv}-mcrypt php%{compatv}-mysql
Provides: php%{compatv}-mysqli php%{compatv}-opcache php%{compatv}-pdo-mysql php%{compatv}-pdo-sqlite
Provides: php%{compatv}-snmp php%{compatv}-soap php%{compatv}-sqlite3 php%{compatv}-xmlreader
Provides: php%{compatv}-xmlwriter php%{compatv}-zip

%description extension
This package include php shared extension


%package dba
Group: Development/Languages
Summary: PHP %{php_mver} dba extension
Summary(ko): PHP %{php_mver} dba 확장
Requires: php%{compatv}api db4 gdbm

%description dba
PHP %{php_mver} Database (dbm-style) Abstraction Layer extension


%package dblib
Group: Development/Languages
Summary: PHP %{php_mver} dblib extension
Summary(ko): PHP %{php_mver} dba 확장
Requires: php%{compatv}api freetds
Provides: php%{compatv}-pdo-dblib

%description dblib
PHP %{php_mver} Microsoft SQL Server and Sybase Functions


%package odbc
Group: Development/Languages
Summary: PHP %{php_mver} odbc and pdo_odbc extension
Summary(ko): PHP %{php_mver} odbc, pdo_odbc 확장
Requires: php%{compatv}api unixODBC

%description odbc
PHP %{php_mver} ODBC and PDO ODBC interface APIs


%package pgsql
Group: Development/Languages
Summary: PHP %{php_mver} pgsql and pdo_pgsql extension
Summary(ko): PHP %{php_mver} pgsql, pdo_pgsql 확장
Requires: php%{compatv}api postgresql-libs

%description pgsql
PHP %{php_mver} pgsql and PDO PgSQL interface APIs


%prep
%setup -q -n php-%{version} -a 100

#pushd $RPM_BUILD_DIR/php-%{version} &> /dev/null
#tar xvfpj %{SOURCE100}
#popd &> /dev/null

# official patch
%patch5001 -p1
%patch5002 -p1
%patch5003 -p1
%patch5004 -p1
%patch5005 -p1
%patch5006 -p1
%patch5007 -p1
%patch5008 -p1
%patch5009 -p1

%patch9000 -p1

# sec
#patch6000 -p1

%patch1 -p1
#patch2 -p1
%patch3 -p1
%if %{build_fpm}
%patch4 -p1
%endif

%patch12 -p1
%patch13 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1

%patch30 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
#patch36 -p1
%patch37 -p1

# fedora patch
%patch100 -p1
%patch101 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1

# private update
%patch3000 -p1

# 3rd party patch
#patch201 -p0
#patch202 -p1

%{?compat_build:%patch10000 -p1}
%{?compat_build:mv sapi/apache2handler/mod_php7.c sapi/apache2handler/mod_php%{compatv}.c}


%if %{_vm_goto}
# memory allocated를 실패하면, swapfile을 생성해서 등록해서 진행할 것!
pushd Zend
	if [ -f "/usr/bin/php" ]; then
		%{__rm} -f zend_vm_execute.h
		php zend_vm_gen.php --with-vm-kind=GOTO

		# 5.6 bug? constant_fetch_end label 중복 에러로, 파일 생성해서
		#중복 수정한 파일 이용
		#%{__rm} -f zend_vm_execute.h
		#%{__install} -m644 %{SOURCE1000} ./zend_vm_execute.h
	fi
popd
%endif

%build

BuildPHP() {
	[ ! -d "%{phpvar}/tmp" ] && mkdir -p %{phpvar}/tmp && chmod 1777 %{phpvar}/tmp
	#OOPS_FLAGS="$RPM_OPT_FLAGS -Wall -fno-strict-aliasing -Wno-pointer-sign"
	RPMS_FLAGS="$RPM_OPT_FLAGS -Wall -fno-strict-aliasing"
	export CFLAGS="-fPIC ${RPMS_FLAGS}"
	export EXTENSION_DIR=%{extdir}
	export PEAR_INSTALLDIR=%{peardir}

	case "$1" in
		cli) scandir="cli"; shift ;;
		apache) scandir="apache"; shift ;;
		fpm) scandir="fpm"; shift ;;
	esac

#		--without-pic \
	%{configure} \
		--with-libdir=%{_lib} \
		--sysconfdir=%{_sysconfdir}/php%{compatv}.d \
		--with-config-file-path=%{_sysconfdir}/php%{compatv}.d \
		--with-config-file-scan-dir=%{_sysconfdir}/php%{compatv}.d/$scandir \
		--disable-debug \
		--disable-opcache \
%if %{_vm_goto}
		--disable-phpdbg \
%endif
		--disable-xmlreader \
		--disable-xmlwriter \
		--disable-json \
		--without-pear \
		--without-sqlite3 \
		--with-bz2 \
		--with-zlib \
		--with-zlib-dir=%{_prefix} \
		--enable-zend-signals \
		--enable-sigchild \
		--enable-sysvsem \
		--enable-sysvshm \
		--enable-sysvmsg \
		--enable-mysqlnd \
		--enable-intl \
		--enable-soap=shared \
		--enable-pdo \
		--without-pdo-sqlite \
		--without-pdo-mysql \
		--enable-sockets \
		--enable-mbstring=all \
		--enable-mbregex \
		--enable-mbregex-backtrack \
		--with-libmbfl \
		--with-iconv \
		--with-openssl \
		--with-xmlrpc \
		--with-system-tzdata \
		--with-mysql-sock=/var/run/mysqld/mysql.sock \
		$*

	%{__make} %{?_smp_mflags}
}

%{__rm} -f configure

# aclocal workaround - to be improved
cat `aclocal --print-ac-dir`/{libtool,ltoptions,ltsugar,ltversion,lt~obsolete}.m4 >>aclocal.m4

# pull latest ltmain.sh, AC_PROG_LIBTOOL
# Force use of system libtool:
libtoolize --force --copy
cat `aclocal --print-ac-dir`/{libtool,ltoptions,ltsugar,ltversion,lt~obsolete}.m4 >build/libtool.m4
# force aclocal run during buildconf
touch acinclude.m4

./buildconf --force

# binary compile
BuildPHP cli \
		--enable-pcntl \
		--with-readline \
		--with-ncurses \
		--enable-ncursesw \
		--disable-cgi \
		--enable-static

mv sapi/cli/php sapi/cli/php-cli
mv sapi/cli/php.1 sapi/cli/php.1.cli
%{__mkdir_p} %{buildroot}%{_bindir}
mv ext/phar/phar.phar ext/phar/phar.phar.cli

%if ! %{build_fpm}
exit 1
%endif

# build fastcgi module
%{__make} clean

%if %{build_fpm}
BuildPHP fpm \
		--enable-fpm \
		--disable-cli \
		--enable-opcache \
		--enable-pcntl

mv sapi/fpm/php-fpm sapi/fpm/php-fpm-back
mv sapi/fpm/php-fpm.8 sapi/fpm/php-fpm.8.fpm
mv sapi/cgi/php-cgi sapi/cgi/php-cgi-back
mv sapi/cgi/php-cgi.1 sapi/cgi/php-cgi.1.cgi

# build apache module
%{__make} clean
%endif

BuildPHP apache \
		--with-apxs2=/usr/sbin/apxs \
		--disable-cli \
		--disable-cgi \
		--enable-bcmath=shared \
		--enable-calendar=shared \
		--with-curl=shared,%{_prefix} \
		--enable-dba=shared \
			--with-gdbm \
			--with-dbm \
			--with-db4 \
		--enable-exif=shared \
		--enable-fileinfo=shared \
		--enable-ftp=shared \
		--with-gd=shared \
			--enable-gd-native-ttf \
			--with-jpeg-dir=%{_prefix} \
			--with-png-dir=%{_prefix} \
			--with-freetype-dir=%{_prefix} \
		--with-gettext=shared \
		--with-gmp=shared \
		--with-imap=shared --with-imap-ssl \
		--enable-json=shared \
		--with-ldap=shared --with-ldap-sasl \
		--with-libevent=shared \
		--with-mcrypt=shared \
		--with-mysql=shared,mysqlnd \
		--with-mysqli=shared,mysqlnd \
		--enable-opcache \
		--with-pdo-dblib=shared,%{_prefix} \
		--with-pdo-mysql=shared,mysqlnd \
		--with-pdo-pgsql=shared \
		--with-pdo-odbc=shared,unixODBC,%{_prefix} \
		--with-pdo-sqlite=shared,%{_prefix} \
		--with-pgsql=shared \
		--enable-shmop=shared \
		--with-snmp=shared,%{_prefix} \
		--enable-soap=shared \
		--with-sqlite3=shared \
		--with-unixODBC=shared,%{_prefix} \
		--enable-wddx=shared \
		--enable-xmlreader=shared \
		--enable-xmlwriter=shared \
		--enable-zip=shared

cd modules
/bin/ls *.so | sed 's/^/;extension = /' > ../extensions.ini
cd -

%install
[ "%{buildroot}" != "/" -a -d "${buildroot}" ] && rm -rf %{buildroot}

%{__mkdir_p} %{buildroot}%{_sysconfdir}/httpd/conf
install -m644 %{SOURCE101} %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf

%{__make} install INSTALL_ROOT=%{buildroot} INSTALL_ID="echo "

rm -rf %{buildroot}%{extdir}
mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{extdir}
mkdir -p %{buildroot}/home/httpd/html
mkdir -p %{buildroot}%{_mandir}/{man1,man8}
mkdir -p %{buildroot}%{_sysconfdir}/php%{compatv}.d/{cli,fpm,apache}

install -m 755 ext/phar/phar.phar.cli %{buildroot}%{_bindir}/phar%{compatv}.phar
cd %{buildroot}%{_bindir}
ln -sf phar%{compatv}.phar phar%{compatv}
cd -

install -m 755 sapi/cli/php-cli %{buildroot}%{_bindir}/php%{compatv}
install -m 644 sapi/cli/php.1.cli %{buildroot}%{_mandir}/man1/php%{compatv}.1
#(cd %{buildroot}%{_bindir}; ln -sf php php7)
install -m 755 -s modules/*.so %{buildroot}%{extdir}
install -m 644 php.ini-production %{buildroot}%{_sysconfdir}/php%{compatv}.d/php.ini
install -m 644 php.ini-production %{buildroot}%{_sysconfdir}/php%{compatv}.d/php-cli.ini
install -m 644 %{SOURCE2} %{buildroot}/home/httpd/html/php_info.php

install -m 644 extensions.ini %{buildroot}%{_sysconfdir}/php%{compatv}.d/apache/shared.ini
install -m 644 extensions.ini %{buildroot}%{_sysconfdir}/php%{compatv}.d/cli/shared.ini

%if %{build_fpm}
%{__mkdir_p} %{buildroot}%{_sbindir}
#install -m 755 sapi/fpm/php-fpm %{buildroot}%{_sbindir}/php%{compatv}-fpm
install -m 755 sapi/fpm/php-fpm-back %{buildroot}%{_sbindir}/php%{compatv}-fpm
install -m 755 sapi/fpm/php-fpm.8.fpm %{buildroot}%{_mandir}/man8/php%{compatv}-fpm.8
install -m 755 sapi/cgi/php-cgi-back %{buildroot}%{_bindir}/php%{compatv}-cgi
install -m 755 sapi/cgi/php-cgi.1.cgi %{buildroot}%{_mandir}/man1/php%{compatv}-cgi.1
%endif

mv %{buildroot}%{_mandir}/man1/php-config.1 %{buildroot}%{_mandir}/man1/php%{compatv}-config.1
mv %{buildroot}%{_mandir}/man1/phpize.1 %{buildroot}%{_mandir}/man1/phpize%{compatv}.1

%{__mkdir_p} %{buildroot}%{peardir}
install -m 644 %{SOURCE102} %{buildroot}/%{peardir}/alias_table.php

mv LICENSE LICENSE.php72

# session and update tmp dir
mkdir -p %{buildroot}%{phpvar}/{sessions,tmp,bin}

# dependency problem
pushd %{buildroot}%{phplib}/build
	chmod 644 *
	chmod 755 shtool
popd

# Generate files lists and stub .ini files for each subpackage
for mod in $(ls %{buildroot}%{extdir}/*.so)
do
	modname=$(basename $mod | sed 's/\.so//g')

	[ "${modname}" = "dba" -o "${modname}" = "pdo_dblib" ] && continue
	[ "${modname}" = "odbc" -o "${modname}" = "pdo_odbc" ] && continue
	[ "${modname}" = "pgsql" -o "${modname}" = "pdo_pgsql" ] && continue

	cat >> files.ext <<EOF
%attr(755,root,root) %{extdir}/${modname}.so
EOF
done

# Package pdo_sqlite with pdo; isolating the sqlite dependency
# isn't useful at this time since rpm itself requires sqlite.
#cat files.pdo_sqlite >> files.pdo

# Install the macros file:
install -d %{buildroot}%{_sysconfdir}/rpm
sed -e "s/@PHP_APIVER@/%{apiver}/;s/@PHP_ZENDVER@/%{zendver}/;s/@PHP_PDOVER@/%{pdover}/" \
    < $RPM_SOURCE_DIR/macros.php > macros.%{?compat_build:php%{compatv}.}php
install -m 644 -c macros.%{?compat_build:php%{compatv}.}php \
           %{buildroot}%{_sysconfdir}/rpm/macros.%{?compat_build:php%{compatv}.}php
%if %{compatv}
cat %{buildroot}%{_sysconfdir}/rpm/macros.%{?compat_build:php%{compatv}.}php | \
	sed 's!php!php%{compatv}!g' > /tmp/php72-compat-sed.php
mv -f /tmp/php72-compat-sed.php %{buildroot}%{_sysconfdir}/rpm/macros.%{?compat_build:php%{compatv}.}php
%endif

cd %{buildroot}%{_sysconfdir}/php%{compatv}.d/
for dname in apache fpm cli
do
	cat >> ${dname}/dba.ini <<EOF
extension = dba.so
EOF

	cat >> ${dname}/dblib.ini <<EOF
extension = pdo_dblib.so
EOF

	cat >> ${dname}/odbc.ini <<EOF
extension = odbc.so
extension = pdo_odbc.so
EOF

	cat >> ${dname}/pgsql.ini <<EOF
extension = pgsql.so
extension = pdo_pgsql.so
EOF
done
cd -

# Remove unpackaged files
rm -rf %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf \
       %{buildroot}%{_bindir}/{phptar} \
       %{buildroot}%{_datadir}/pear

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}
rm -f files.* macros.%{?build_compat:php%{compatv}.}php


%files
%defattr(-,root,root)
%{!?compat_build:%attr(755,root,root) %{_libdir}/httpd/modules/libphp7.so}
%{?compat_build:%attr(755,root,root) %{_libdir}/httpd/modules/libphp%{compatv}.so}
#{peardir}/alias_table.php
%dir %{phplib}
%dir %{phplib}/extensions
#attr(755,nobody,nobody) %dir %{phpvar}/sessions
#attr(1777,root,root) %dir %{phpvar}/tmp
#attr(755,root,root) %dir %{phpvar}/bin

%files cli
%defattr(-,root,root)
%attr(755,root,root) %{_bindir}/php%{compatv}
%attr(755,root,root) %{_bindir}/phar%{compatv}.phar
%{_bindir}/phar%{compatv}
%{_mandir}/man1/php%{compatv}.1*

%if %{build_fpm}
%files fpm
%attr(755,root,root) %{_sbindir}/php%{compatv}-fpm
%attr(755,root,root) %{_bindir}/php%{compatv}-cgi
%{_mandir}/man1/php%{compatv}-cgi.1*
%{_mandir}/man8/php%{compatv}-fpm.8*
%endif

%files devel
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/rpm/macros.%{?compat_build:php%{compatv}.}php
%{_bindir}/php%{compatv}-config
%{_bindir}/phpize%{compatv}
%{_includedir}/php%{compatv}
%{_libdir}/php%{compatv}/build
%{_mandir}/man1/php%{compatv}-config.1*
%{_mandir}/man1/phpize%{compatv}.1*

%files extension -f files.ext

%files dba
%attr(755,root,root) %{extdir}/dba.so
%attr(644,root,root) %{_sysconfdir}/php%{compatv}.d/apache/dba.ini
%attr(644,root,root) %{_sysconfdir}/php%{compatv}.d/fpm/dba.ini
%attr(644,root,root) %{_sysconfdir}/php%{compatv}.d/cli/dba.ini

%files dblib
%attr(755,root,root) %{extdir}/pdo_dblib.so
%attr(644,root,root) %{_sysconfdir}/php%{compatv}.d/apache/dblib.ini
%attr(644,root,root) %{_sysconfdir}/php%{compatv}.d/fpm/dblib.ini
%attr(644,root,root) %{_sysconfdir}/php%{compatv}.d/cli/dblib.ini

%files odbc
%attr(755,root,root) %{extdir}/odbc.so
%attr(755,root,root) %{extdir}/pdo_odbc.so
%attr(644,root,root) %{_sysconfdir}/php%{compatv}.d/apache/odbc.ini
%attr(644,root,root) %{_sysconfdir}/php%{compatv}.d/fpm/odbc.ini
%attr(644,root,root) %{_sysconfdir}/php%{compatv}.d/cli/odbc.ini

%files pgsql
%attr(755,root,root) %{extdir}/pgsql.so
%attr(755,root,root) %{extdir}/pdo_pgsql.so
%attr(644,root,root) %{_sysconfdir}/php%{compatv}.d/apache/pgsql.ini
%attr(644,root,root) %{_sysconfdir}/php%{compatv}.d/fpm/pgsql.ini
%attr(644,root,root) %{_sysconfdir}/php%{compatv}.d/cli/pgsql.ini

%changelog
* Fri Jan 11 2019 JoungKyun.Kim <hostmaster@oops.org> 2:7.2.14-1%{?dist}
- update 7.2.14
  . http://www.php.net/ChangeLog-7.php#7.2.14
  . http://www.php.net/ChangeLog-7.php#7.2.13
  . http://www.php.net/ChangeLog-7.php#7.2.12
  . http://www.php.net/ChangeLog-7.php#7.2.11
  . http://www.php.net/ChangeLog-7.php#7.2.10
  . http://www.php.net/ChangeLog-7.php#7.2.9
  . http://www.php.net/ChangeLog-7.php#7.2.8

- 7.2.14 official bugs
  . fixed #77391 GD: 1bpp BMPs may fail to be loaded.
  . fixed #75684 MySQLnd: In mysqlnd_ext_plugin.h the plugin methods family has no external visibility.
  . fixed #77273 PD0: array_walk_recursive corrupts value types leading to PDO failure.
  . fixed #77395 Standard: segfault about array_multisort.
  . fixed #77339 Core: __callStatic may get incorrect arguments
  . fixed #73281 GD: imagescale(…, IMG_BILINEAR_FIXED) can cause black border
  . fixed #77272 GD: imagescale() may return image resource on failure
  . fixed #77439 Standard: parse_str segfaults when inserting item into existing array
  . fixed #76839 Sockets: socket_recvfrom may return an invalid 'from' address on MacOS

- security issues:
  . CVE-2018-17082 Apache2: XSS due to the header Transfer-Encoding: chunked (#76582)
  . CVE-2018-12882 EXIF: heap use after free in _php_stream_free (#76409)
  . CVE-2018-14883 EXIF: Int Overflow lead to Heap OverFlow in exif_thumbnail_extract of exif.c (#76423)
  . CVE-2018-14851 EXIF: heap-buffer-overflow (READ of size 48) while reading exif data (#76557)

- ncurses extension update (only cli)

* Sun Jul  8 2018 JoungKyun.Kim <hostmaster@oops.org> 2:7.2.7-1%{?dist}
- update 7.2.7
  . http://www.php.net/ChangeLog-7.php#7.2.7

- 7.2.7 official bugs
  . fixed #76534 Core: PHP hangs on 'illegal string offset on string references with an error handler
  . fixed #76520 Core: Object creation leaks memory when executed over HTTP
  . fixed #76502 Core: Chain of mixed exceptions and errors does not serialize properly
  . fixed #76462 Date: Undefined property: DateInterval::$f
  . fixed #76409 EXIF: heap use after free in _php_stream_free
  . fixed #73342 FPM: Vulnerability in php-fpm by changing stdin to non-blocking
  . fixed #74670 GMP: Integer Underflow when unserializing GMP and possible other classes
  . fixed #76556 intl: get_debug_info handler for BreakIterator shows wrong type
  . fixed #76532 mbstring: Integer overflow and excessive memory usage in mb_strimwidth
  . fixed #76477 Opcache: Opcache causes empty return value
  . fixed #76548 PGSQL: pg_fetch_result did not fetch the next row
  . fixed #76536 Reflection: PHP crashes with core dump when throwing exception in error handler
  . fixed #75231 Reflection: ReflectionProperty#getValue() incorrectly works with inherited classes
  . fixed #76505 Standard: array_merge_recursive() is duplicating sub-array keys
  . fixed #71848 Standard: getimagesize with $imageinfo returns false
  . fixed #76461 ZIP: OPSYS_Z_CPM defined instead of OPSYS_CPM

- 7.2.8 official bugs
  . Fixed bug #76366 Filter: References in sub-array for filtering breaks the filter

- security issues
  . CVE-2018-10549 Exif: Heap Buffer Overflow (READ: 1786) in exif_iif_add_value (#76130)
  . CVE-2018-10546 iconv: stream filter convert.iconv leads to infinite loop on invalid sequence (#76249)
  . CVE-2018-10548 ldap: Malicious LDAP-Server Response causes Crash (#76248)
  . CVE-2018-10547 Phar: fix for CVE-2018-5712 may not be complete (#76129)
  . CVE-2018-10545 FPM: Dumpable FPM child processes allow bypassing opcache access controls (#75605)

* Mon Mar 19 2018 JoungKyun.Kim <hostmaster@oops.org> 2:7.2.3-1%{?dist}
- update 7.2.3
  . http://www.php.net/ChangeLog-7.php#7.2.3

- 7.2.3 official bugs
  . fixed #76025 Core: Segfault while throwing exception in error_handler
  . fixed #73957 GD: signed integer conversion in imagescale()
  . fixed #76041 GD: null pointer access crashed php
  . fixed #62545 Mbstring: wrong unicode mapping in some charsets
  . fixed #75969 Opcache: Assertion failure in live range DCE due to block pass misoptimization
  . fixed #76085 Phar: Segmentation fault in buildFromIterator when directory name contains a \n
  . fixed #76068 Standard: parse_ini_string fails to parse "[foo]\nbar=1|>baz" with segfault

- 7.2.4 official bugs
  . fixed #76094 Opcache: Access violation when using opcache
  . fixed #74139 Standard: mail.add_x_header default inconsistent with docs

- security issues
  . CVE-2018-7584 stack-buffer-overflow while parsing HTTP response (#75981)

* Fri Feb 16 2018 JoungKyun.Kim <hostmaster@oops.org> 2:7.2.2-2%{?dist}
- 7.2.2 official bugs
  . fixed #75916 Standard: DNS_CAA record results contain garbage
  . fixed #75928 Date: Argument 2 for `DateTimeZone::listIdentifiers()` should accept `null`
  . fixed #75857 Date: Timezone gets truncated when formatted
  . fixed #68406 Date: calling var_dump on a DateTimeZone object modifies it
  . fixed #49876 LDAP: Fix LDAP path lookup on 64-bit distros
  . fixed #75838 PGSQL: Memory leak in pg_escape_bytea()
  . fixed #54289 Phar: Phar::extractTo() does not accept specific directories to be extracted
  . fixed #65414 Phar: deal with leading slash while adding files correctly
  . fixed #73725 ODBC: Unable to retrieve value of varchar(max) type
  . fixed #75729 Opcache: opcache segfault when installing Bitrix
  . fixed #75893 Opcache: file_get_contents $http_response_header variable bugged with opcache
  . fixed #75938 Opcache: Modulus value not stored in variable
  . fixed #74519 SPL: strange behavior of AppendIterator

* Thu Feb  8 2018 JoungKyun.Kim <hostmaster@oops.org> 2:7.2.2-1%{?dist}
- udpate 7.2.2
  . http://www.php.net/ChangeLog-7.php#7.2.2
